'\"
'\" Generated from file '' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2005 Michael Kirkham & Muonics
'\"
'\" -*- tcl -*- doctools manpage
'\" $Id: tclmilter.n,v 1.1 2005/06/26 22:09:06 muonics Exp $
.so man.macros
.TH "TclMilter" n 1.0  "Tcl interface to SendMail's Milter API"
.BS
.SH "NAME"
TclMilter \- Tcl interface to SendMail's Milter API
.SH "SYNOPSIS"
package require \fBTcl  8.1\fR
.sp
package require \fBTclMilter  ?1.0?\fR
.sp
\fBmilter configure\fR ?\fIoption\fR ?value?? ...\fR
.sp
\fBmilter main\fR \fR
.sp
\fBmilter register\fR \fIevent\fR ?\fIcallback\fR?\fR
.sp
\fBmilter register connect\fR \fIconnectProc\fR\fR
.sp
\fBmilter register helo\fR \fIheloProc\fR\fR
.sp
\fBmilter register envfrom\fR \fIenvfromProc\fR\fR
.sp
\fBmilter register envrcpt\fR \fIenvrcptProc\fR\fR
.sp
\fBmilter register header\fR \fIheaderProc\fR\fR
.sp
\fBmilter register eoh\fR \fIeohProc\fR\fR
.sp
\fBmilter register body\fR \fIbodyProc\fR\fR
.sp
\fBmilter register eom\fR \fIeomProc\fR\fR
.sp
\fBmilter register abort\fR \fIabortProc\fR\fR
.sp
\fBmilter register close\fR \fIcloseProc\fR\fR
.sp
\fBmilter stop\fR \fR
.sp
\fIcontext\fR \fBgetpriv\fR ?\fIname\fR?\fR
.sp
\fIcontext\fR \fBgetsymval\fR \fIsymbol\fR\fR
.sp
\fIcontext\fR \fBsetpriv\fR \fIname\fR ?\fIvalue\fR?\fR
.sp
\fIcontext\fR \fBsetreply\fR \fIrcode\fR ??\fIxcode\fR? \fImessage\fR?\fR
.sp
\fIcontext\fR \fBunsetpriv\fR ?\fIpattern\fR?\fR
.sp
\fIcontext\fR \fBaddheader\fR \fIname\fR \fIdata\fR\fR
.sp
\fIcontext\fR \fBaddrcpt\fR \fIrcpt\fR\fR
.sp
\fIcontext\fR \fBchgheader\fR \fIname\fR ?\fIindex\fR? \fIdata\fR\fR
.sp
\fIcontext\fR \fBdelrcpt\fR \fIrcpt\fR\fR
.sp
\fIcontext\fR \fBinsheader\fR \fIname\fR ?\fIindex\fR? \fIdata\fR\fR
.sp
\fIcontext\fR \fBreplacebody\fR \fIdata\fR\fR
.sp
\fIcontext\fR \fBprogress\fR\fR
.sp
\fIcontext\fR \fBquarantine\fR \fIreason\fR\fR
.sp
.BE
.SH "DESCRIPTION"
.PP
\fITclMilter\fR [http://www.muonics.com/FreeStuff/TclMilter/] is a package
for Tcl (written in C) that implements an
interface to SendMail's Milter (Mail Filter) API for developing
custom scripted message rewriting and spam filtering processes. A
thread-enabled Tcl build is required due to Milter's threading
requirements. However, you can only run, configure, or register
callbacks for a milter from the first thread/interpreter the package
is loaded into. If you need to be able to stop the milter from
within Tcl, you can load the package in another thread to do so.
Only the "milter stop" command will function in secondary threads.
.PP
TclMilter follows libmilter's APIs very closely, with the following
exceptions for readability and flexibility:
.IP \(bu
The \fBsmfi_opensocket\fR command is not provided, only \fBmilter main\fR
as an interface to \fBsmfi_main\fR.
.IP \(bu
The \fBsmfi_setconn\fR, \fBsmfi_settimeout\fR, \fBsmfi_setbacklog\fR and
\fBsmfi_setdbg\fR commands, as well as settings normally provided
through \fBsmfi_main\fR  are instead provided as \fBmilter configure\fR
options.
.IP \(bu
The \fBsmfi_register\fR command is provided as \fBmilter register\fR;
however, unlike libmilter it's possible to register and unregister
callbacks at any time, rather than just once prior to calling \fBmain\fR.
.IP \(bu
There isn't a single data storage value for \fBsmfi_setpriv\fR; rather,
TclMilter's \fBmilter setpriv\fR command uses a hash table so you can
set individual, custom variables with data to associate with a context.
.IP \(bu
The context provided to callbacks is not simply a pointer, but is
an actual Tcl command that can be used to interact with the context.
.SH "RETURN CODES"
.PP
Callbacks are invoked by TclMilter at various stages of message processing
in order to provide a filter with all of the information about the
MTA connection and message being sent.  These callbacks may return one
of five values to indicate to SendMail whether to continue processing
the message or whether to reject it for some reason.
.IP \(bu
\fBSMFIS_CONTINUE\fR - Indicates that message processing should continue,
and that other callbacks should continue to be called (i.e., the message
is neither accepted or rejected yet).  Callbacks should always return
this value by default.
.IP \(bu
\fBSMFIS_REJECT\fR - Indicates that the message should be rejected
immediately.  The milter may use \fIcontext\fR \fBsetreply\fR prior
to returning this value to indicate the status code and reason for the
rejection.
.IP \(bu
\fBSMFIS_DISCARD\fR - Indicates that the message should be discared
immediately.
.IP \(bu
\fBSMFIS_ACCEPT\fR - Indicates that the message should be accepted
as far as this milter is concerned.  No other callbacks will be
invoked.  However, the message may still be rejected for other
reasons - either by other milters or by SendMail itself.
.IP \(bu
\fBSMFIS_TEMPFAIL\fR - Indicates that the message should be rejected
immediately with a temporary failure.  The milter may use \fIcontext\fR
\fBsetreply\fR prior to returning this value to indicate the status
code and reason for the rejection.
.SH "MILTER CONTROL FUNCTIONS"
.TP
\fBmilter configure\fR ?\fIoption\fR ?value?? ...\fR
Configure Milter session parameters.  Given no options, returns a list
of option/value pairs indicating current milter configuration.  Given
an \fIoption\fR and no values, returns the current value of the
specified option.  Otherwise, each option is set to the given value.
.RS
.TP
\fB\fB-name\fR\fR \fIname\fR
Specifies the name for the milter.  This should be a unique name among
all the milters being used by the MTA, and it must be set before calling
\fBmilter main\fR if at all.  The default is "TclMilter".
.TP
\fB\fB-connection\fR\fR \fIfoo\fR
Specifies the type of connection to use for communicating with SendMail,
as well as the appropriate parameters for the connection type.  It must be
set before calling \fBmilter main\fR if at all.  Per libmilter's
\fIsmfi_setconn\fR [http://www.milter.org/milter_api/smfi_setconn.html]
documentation, the format is "proto:address":
.RS
.IP \(bu
{unix|local}:/path/to/file -- A named pipe.
.IP \(bu
inet:port@{hostname|ip-address} -- An IPV4 socket.
.IP \(bu
inet6:port@{hostname|ip-address} -- An IPV6 socket.
.RE
.sp
The default is "unix:/var/run/tclmilter.sock" - a pipe socket using the
file "\fI/var/run/tclmilter.sock\fR".
.TP
\fB\fB-timeout\fR\fR \fIseconds\fR
Specifies the number of seconds that the Milter should wait for an MTA
connection before timing out. The timer can be reset using the \fIcontext\fR
\fBprogress\fR command.  This setting may only be changed
prior to calling \fBmilter main\fR.  Default: 7210 seconds.
.TP
\fB\fB-backlog\fR\fR \fIcount\fR
Configures the number of incoming connections that the milter will
allow in the listen queue.  This setting may only be changed prior to
\fBmilter main\fR.  The default for the milter is the system default.
.TP
\fB\fB-debuglevel\fR\fR \fIlevel\fR
Configures the level of debug information that will be logged by libmilter.
This setting may be changed at any time.  Default: 0.
.RE
.sp
.TP
\fBmilter main\fR \fR
Opens the socket to allow connection to SendMail and to begin filtering mail.
This command will not return unless \fBmilter stop\fR is called or the
milter receives a signal requiring a shutdown, such as SIGHUP.
.TP
\fBmilter register\fR \fIevent\fR ?\fIcallback\fR?\fR
Register a callback for TclMilter to invoke at the specified stage on
mail processing.  Callbacks are supported corresponding to each of
those provided by libmilter its self.  Unlike libmilter, which must
have callbacks specified by the call to smfi_main(), callbacks for
TclMilter may be registered or unregistered at any time.
The \fIcallback\fR argument specifies the name of the procedure
for TclMilter to invoke for the specified event.  If this argument
is not provided, the command will return the name of the currently
registered callback procedure for the specified event.
.sp
The type and arguments that the callback receives depend on the
event, although every callback is provided with a unique context
ID that can be used to manipulate the message being processed.
Supported event types are as follows:
.RS
.TP
\fBmilter register connect\fR \fIconnectProc\fR\fR
Arranges for proc \fIconnectProc\fR to be called when a connection is
established to sendmail, before the exchange of HELO greetings.  The
callback is appended with three arguments: the context command,
the hostname and a list containing a dictionary of information from
the sockaddr stucture (e.g., address and port).
.sp
proc \fIconnectProc\fR { context hostname addrInfo } { ... }
.TP
\fBmilter register helo\fR \fIheloProc\fR\fR
Arranges for proc \fIheloProc\fR to be called when the client sends
its HELO greeting command.  The command is appended with two arguments:
the context and the hostname as provided in the HELO command.
.sp
proc \fIheloProc\fR { context helohost } { ... }
.TP
\fBmilter register envfrom\fR \fIenvfromProc\fR\fR
Arranges for proc \fIenvfromProc\fR to be called when the client sends
the MAIL FROM command.  The command is appended with two elements:
the context command and a list of all of the addresses specified
in the MAIL FROM envelope.
.sp
proc \fIenvfromProc\fR { context fromList } { ... }
.TP
\fBmilter register envrcpt\fR \fIenvrcptProc\fR\fR
Arranges for proc \fIenvrcptProc\fR to be called when the client sends
the RCPT TO command.  The command is appended with two elements:
teh context command and a list of all of the addresses specified
in the RCPT TO envelope.
.sp
proc \fIenvrcptProc\fR { context rcptList } { ... }
.TP
\fBmilter register header\fR \fIheaderProc\fR\fR
Arranges for proc \fIheaderProc\fR to be called for each header sent
by the client.  The command is appended with three elements: the
context command, the header name and the contents of the header.
.sp
proc \fIheaderProc\fR { context name content } { ... }
.TP
\fBmilter register eoh\fR \fIeohProc\fR\fR
Arranges for proc \fIeohProc\fR to be called once all headers have
been sent and handled by the milter's "header" callback, before the
message body is sent.  The command is appended with one argument:
the context command.
.sp
proc \fIeohProc\fR { context } { ... }
.TP
\fBmilter register body\fR \fIbodyProc\fR\fR
Arranges for proc \fIbodyProc\fR to be called for each block of
data in the message body.  The command is appended with two elements:
the context command and the body text.  Each message has only one
body, but this body may be sent in multiple blocks.  If the milter
intends to do content filtering on the message body, it is recommended
to use \fIcontext\fR \fBsetpriv\fR to build and store the complete
message body and perform content filtering in the \fBeom\fR callback.
.sp
proc \fIbodyProc\fR { context block } { ... }
.TP
\fBmilter register eom\fR \fIeomProc\fR\fR
Arranges for proc \fIeomProc\fR to be called once once all message
information has been received, including the entire message body,
and processed by the milter.  All message rewriting, such as adding
and removing headers or changing the body, must be performed
within this callback.  The command is appended with one element: the
context command.
.sp
proc \fIeomProc\fR { context } { ... }
.TP
\fBmilter register abort\fR \fIabortProc\fR\fR
Arranges for proc \fIabortProc\fR to be called if message transmission
is aborted, such as due to a dropped connection.  This callback is not
invoked if message transmission is completed.  The command is appended
with one element: the context command.
.sp
proc \fIabortProc\fR { context } { ... }
.TP
\fBmilter register close\fR \fIcloseProc\fR\fR
Arranges for proc \fIcloseProc\fR to be called when the client connection
has been closed.  This callback is not invoked if message transmission
is aborted.  The command is appended with one element: the context command.
.sp
proc \fIcloseProc\fR { context } { ... }
.RE
.sp
.TP
\fBmilter stop\fR \fR
Stop the milter, causing \fBmilter main\fR to return.  Note that,
due to libmilter limitations, it is currently not possible to restart
the milter once stopped.  You will have to exit Tcl and then restart,
reload the package, etc. in order to start the milter up again.
.SH "DATA ACCESS FUNCTIONS"
.PP
The following context functions may be invoked from any callback to get
or store information about the message context or sendmail configuration.
Each context has a hash table associated with it, and a set of accessor
functions that work similar to Tcl's own \fBset\fR command, allowing
the milter to associate data with each message that can be passed around
between callbacks and automatically garbage collected when the context
is deleted.
.TP
\fIcontext\fR \fBgetpriv\fR ?\fIname\fR?\fR
If \fIname\fR is provided, this command returns the value from the hash
table with the given key \fIname\fR.  If \fIname\fR is unspecified, a
list of \fIname value\fR pairs is returned with all of the private
data associated with the context, in dictionary format (i.e., suitable
for use with \fBarray set\fR).
.TP
\fIcontext\fR \fBgetsymval\fR \fIsymbol\fR\fR
Returns the value for the specified symbol in the SendMail configuration.
The \fIsymbol\fR may be either a single letter or a keyword surrounded
in {braces}.  Consult the libmilter and/or SendMail documentation for
more details.
.TP
\fIcontext\fR \fBsetpriv\fR \fIname\fR ?\fIvalue\fR?\fR
Sets the specified value within the context's private hash table using
the given variable name/key \fIname\fR.  If \fIvalue\fR is not specified,
returns the current value for the specified key, as with \fBgetpriv\fR.
.TP
\fIcontext\fR \fBsetreply\fR \fIrcode\fR ??\fIxcode\fR? \fImessage\fR?\fR
Sets the specific reply/status code for the message to be returned to the
client MTA and, optionally, the extended reply code and a message (such
as a reason for rejecting the message).
.TP
\fIcontext\fR \fBunsetpriv\fR ?\fIpattern\fR?\fR
This command could be considered a hybrid of Tcl's \fBunset\fR and
\fBarray unset\fR commands.  It removes each variable whose name
matches the specified glob-style pattern from the context's private
data hash table.  If no pattern is specified then all private
data is deleted from the context.
.SH "MESSAGE MODIFICATION FUNCTIONS"
.PP
The following context functions may be invoked ONLY from the eom callback
to modify message contents.  The result of invoking these commands in
other callbacks is undefined.
.TP
\fIcontext\fR \fBaddheader\fR \fIname\fR \fIdata\fR\fR
Adds a new header to the message with the given header \fIname\fR and contents \fIdata\fR.
.TP
\fIcontext\fR \fBaddrcpt\fR \fIrcpt\fR\fR
Instructs sendmail to deliver the message to the specified recipient
in addition to any others the message is already being sent to, provided
the message is not rejected.
.TP
\fIcontext\fR \fBchgheader\fR \fIname\fR ?\fIindex\fR? \fIdata\fR\fR
Changes an existing header in the message with the given header \fIname\fR
to the contents \fIdata\fR.  The \fIindex\fR value specifies which
instance of the header is to be modified.  If unspecified, the first
instance of the header will be modified.  If no such header exists, it
will be added.
.TP
\fIcontext\fR \fBdelrcpt\fR \fIrcpt\fR\fR
Instructs sendmail NOT to deliver the message to specified recipient.  The
message may still be delivered to other recipients, provided the message
is not rejected.
.TP
\fIcontext\fR \fBinsheader\fR \fIname\fR ?\fIindex\fR? \fIdata\fR\fR
Inserts a new header into the message with the given header \fIname\fR
and contents \fIdata\fR.  By default, headers are inserted
with \fIindex\fR 0 - that is, they are inserted as the first header.
Otherwise, they are inserted before the \fIindex\fRth header.  If
\fIindex\fR is greater than the number of headers in the message,
the new header is added at the end, as with \fBaddheader\fR.
.TP
\fIcontext\fR \fBreplacebody\fR \fIdata\fR\fR
Replaces the entire message body with \fIdata\fR.  This can be useful,
for example, to remove questionable attachments or change message encoding.
.SH "OTHER MESSAGE HANDLING FUNCTIONS"
.PP
The following context functions may be invoked ONLY from the eom callback.
The result of invoking these commands in other callbacks is undefined.
.TP
\fIcontext\fR \fBprogress\fR\fR
This command may be called during long processes to inform SendMail/libmilter
that the message is still being processed.  When called, the timeout
clock is reset.
.TP
\fIcontext\fR \fBquarantine\fR \fIreason\fR\fR
This command may be called to quarantine the message.  The message is
neither rejected nor delivered, but is left in the mail queue, requiring
administrator action to be delivered or unqueued.
.SH "EXAMPLE"
.nf
#!/usr/local/bin/tclsh
#
# A simple email address-based blacklist milter
#

package require Tcl 8.4
package require TclMilter 1.0

# Configuration

set blacklist {
    friend@public.com
    spammer@spamdomain.com
}

milter configure -name Blacklist
milter configure -connection {unix:/var/run/blmilter.sock}

# Check to see if an address is on the blacklist

proc is_blacklisted { address } {
    set address [string trim $address <>]

    if {[lsearch -exact $::blacklist $address] != -1} {
        return 1
    }

    return 0
}

# Callbacks

proc bl_header { context name data } {
    if {($name == "From") && [is_blacklisted $data]} {
        return SMFIS_REJECT
    }

    return SMFIS_CONTINUE
}

proc bl_envfrom { context addressList } {
    foreach address $addressList {
        if {[is_blacklisted $address]} {
            return SMFIS_REJECT
        }
    }

    return SMFIS_CONTINUE
}

# Register the callbacks and start up the filter

milter register header bl_header
milter register envfrom bl_envfrom
milter main
file delete /var/run/blmilter.sock
.fi
.SH "LICENSE"
TclMilter is provided under the GNU General Public License
(GPL) (see the file "\fIlicense.terms\fR" for details).
.SH "ACKNOWLEDGEMENTS"
Portions of this document, as well as the package its self, are based on the
Milter API specification.
.SH "SEE ALSO"
\fIMilter API\fR [http://www.milter.org/milter_api/api.html], \fIRFC 1893\fR [http://www.muonics.com/rfc/rfc1893.php], \fIRFC 2034\fR [http://www.muonics.com/rfc/rfc2034.php], \fIRFC 2821\fR [http://www.muonics.com/rfc/rfc2821.php], \fIRFC 821\fR [http://www.muonics.com/rfc/rfc821.php]
.SH "KEYWORDS"
email, filter, milter, sendmail, spam, tcl
.SH "COPYRIGHT"
.nf
Copyright (c) 2005 Michael Kirkham & Muonics
.fi
